/*
 * File   :     MyImages.java
 * Author :     Tis Veugen
 * Date   :     1999-01-03
 * PBN    :     1.0
 */

import java.applet.*;
import java.net.URL;
import java.awt.*;
//import java.awt.image.ImageProducer;
import java.io.*;

public class MyImages
{
  private static final int	NR_CONTROL = 6;
  private static final int	NUMBER = PbnTrump.NUMBER+NR_CONTROL+PbnTrump.NUMBER;

  private static Image []	maImages = new Image [ NUMBER ];

  private static String []      maImageNames =
  {
    "c.gif",
    "d.gif",
    "h.gif",
    "s.gif",
    "nt.gif",
    "cmd_0.gif",
    "cmd_1.gif",
    "cmd_2.gif",
    "cmd_3.gif",
    "cmd_4.gif",
    "cmd_5.gif",
    "c12.gif",
    "d12.gif",
    "h12.gif",
    "s12.gif"
  };

  public static Image		Get(
  PbnSuit			oSuit )
  {
    if ( ! oSuit.IsValid() )
    {
      return null;
    }
    return maImages[ oSuit.Get() ];
  }

  public static Image		Get(
  PbnTrump			oTrump )
  {
    if ( ! oTrump.IsValid() )
    {
      return null;
    }
    return maImages[ oTrump.Get() ];
  }

  public static Image		Get(
  int                           iControl )
  {
    return maImages[ PbnTrump.NUMBER + iControl ];
  }

  public static Image		Get12(
  PbnSuit			oSuit )
  {
    if ( ! oSuit.IsValid() )
    {
      return null;
    }
    return maImages[ PbnTrump.NUMBER+NR_CONTROL+oSuit.Get() ];
  }

  public static Image		Get12(
  PbnTrump			oTrump )
  {
    if ( ! oTrump.IsValid() )
    {
      return null;
    }
    return maImages[ PbnTrump.NUMBER+NR_CONTROL+oTrump.Get() ];
  }

  public static void 		Load(
  Component			oComponent )
  {
    MediaTracker                lMediaTracker = new MediaTracker( oComponent );

    try
    {
      for ( int i = 0; i < NUMBER; i++ )
      {
        lMediaTracker.addImage( maImages[ i ], 0 );
        lMediaTracker.waitForID( 0 );
      }
    }
    catch( InterruptedException oEvent )
    {
      oEvent.printStackTrace();
    }
  }

  public static void            GetImages()
  {
    Toolkit                     tk = Toolkit.getDefaultToolkit();

    for ( int i = 0; i < NUMBER-1; i++ )
    {
//      maImages[ i ] = tk.getImage( maImageNames[ i ] );
      maImages[ i ] = null;
      try
      {
        InputStream is = ClassLoader.getSystemResourceAsStream( maImageNames[ i ] );
        byte []     bs = PbnU.Stream2Bytes( is );
        if ( bs != null )
      	{
          maImages[ i ] = tk.createImage( bs );
      	}
      }
      catch ( Exception e )
      {
      }
    }
    maImages[ PbnTrump.NUMBER+NR_CONTROL + PbnTrump.NOTRUMP ] =
                maImages[ PbnTrump.NOTRUMP ];
  }

  public static void            GetImages(
  Applet                        oApplet )
  {
    for ( int i = 0; i < NUMBER-1; i++ )
    {
      maImages[ i ] = null;
//      maImages[ i ] = oApplet.getImage( oApplet.getCodeBase()
//                                      , maImageNames[ i ] );
      try
      {
//        URL url = oApplet.getClass().getResource( maImageNames[ i ] );
//        maImages[ i ] = oApplet.createImage( (ImageProducer) url.getContent() );
        InputStream is = oApplet.getClass().getResourceAsStream( maImageNames[ i ] );
        byte []     bs = PbnU.Stream2Bytes( is );
        if ( bs != null )
      	{
          maImages[ i ] = oApplet.getToolkit().createImage( bs );
      	}
      }
      catch ( Exception e )
      {
      }
    }
    maImages[ PbnTrump.NUMBER+NR_CONTROL + PbnTrump.NOTRUMP ] =
                maImages[ PbnTrump.NOTRUMP ];

    Load( oApplet );
  }
}
