/*
 * File   :     PbnTimer.java
 * Author :     Tis Veugen
 * Date   :     1999-01-03
 * PBN    :     1.0
 */

import java.awt.*;
import java.awt.event.*;

public class PbnTimer extends Component
  implements Runnable
{
  private static int            mTimerId = 0;

  private int                   mId;
  private Thread                mThread;
  private static EventQueue     mEventQueue;
  private TimerListener         mTimerListener;
  private int                   mInterval;

  public                        PbnTimer()
  {
    mThread = new Thread( this );
    mEventQueue = Toolkit.getDefaultToolkit()
                         .getSystemEventQueue();
    enableEvents( 0 );
  }

  public int                    Start(
  int                           iMilliSecs )
  {
    mId = ++mTimerId;

    mInterval = iMilliSecs;
    mThread.start();

    return mId;
  }

  public void                   Stop()
  {
    mThread.stop();
  }

  public void                   addTimerListener(
  TimerListener                 oTimerListener )
  {
    mTimerListener = oTimerListener;
  }

  public void run()
  {
    for ( ; ; )
    {
      try
      {
        Thread.sleep( mInterval );
      }
      catch( InterruptedException e )
      {}
      TimerEvent te = new TimerEvent( this, mId );
      mEventQueue.postEvent( te );
    }
  }

  public void                   processEvent(
  AWTEvent                      oAWTEvent )
  {
    if ( oAWTEvent instanceof TimerEvent )
    {
      if ( mTimerListener != null )
      {
        mTimerListener.timeElapsed( (TimerEvent) oAWTEvent );
      }
    }
    else
    {
      super.processEvent( oAWTEvent );
    }
  }
}
