/*
 * File   :     PbnTrick.java
 * Author :     Tis Veugen
 * Date   :     2004-08-23
 * PBN    :     1.0
 *
 * History
 * -------
 * 2004-08-23 Added Rotate()
 */

public class PbnTrick
{
  static final int              NUMBER = 13;

  private PbnCard []            maCards;

  public                        PbnTrick()
  {
    maCards = new PbnCard[ PbnSide.NUMBER ];

    for ( int i = 0; i < PbnSide.NUMBER; i++ )
    {
      maCards[ i ] = new PbnCard();
    }
  }

  public PbnCard                Get(
  PbnSide                       oSide )
  {
    return maCards[ oSide.Get() ];
  }

  public void                   Set(
  PbnSide                       oSide,
  PbnCard                       oCard )
  {
    maCards[ oSide.Get() ].Set( oCard );
  }

  public void                   Rotate(
  int                           number )
  {
    PbnCard []                  laCards = new PbnCard[ PbnSide.NUMBER ];
    PbnSide                     lSide = new PbnSide( PbnSide.SOUTH );
    PbnSide                     lPrevSide;

    for ( int i = 0; i < PbnSide.NUMBER; i++ )
    {
      lPrevSide = lSide.toSide( -number );
      laCards[ lSide.Get() ] = maCards[ lPrevSide.Get() ];
      lSide.Next();
    }
    maCards = laCards;
  }
}
