/*
 * File   :     PbnViewApplet.java
 * Author :     Tis Veugen
 * Date   :     2007-08-27
 * PBN    :     2.1
 *
 * History
 * -------
 * 2001-09-20 Made uniform files
 * 2007-08-27 Added VERSION_21
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import java.applet.*;
import java.net.*;

public class PbnViewApplet extends Applet
{
  private boolean               mbVwApplet = true;
  private Frame                 mFrame = null;

  private PanelScreen		    mPanelScreen;
  private PbnVwHndlr		    mPbnVwHndlr;
  private PbnMenu   		    mPbnMenu;

  public void                   SetFrame(
  Frame                         lFrame )
  {
    mbVwApplet = false;
    mFrame = lFrame;
  }

  public void                   init()
  {
    PbnViewer.mbApplet = mbVwApplet;
    PbnGen.SetNoVerify();
    PbnGen.SetVersion( PbnGen.VERSION_21 );

    if ( PbnViewer.mbApplet )
    {
      MyImages.GetImages( this );
    }
    else
    {
      MyImages.GetImages();
    }
    mPbnVwHndlr  = new PbnVwHndlr();

    if ( mFrame != null )
    {
      mPbnMenu = new PbnMenu( mFrame, mPbnVwHndlr );
    }

    mPanelScreen = new PanelScreen( mPbnVwHndlr );
    mPbnVwHndlr.SetPanelScreen( mPanelScreen );
    add( mPanelScreen );

    if ( PbnViewer.mbApplet )
    {
      LoadUrlFile();
    }
  }

  private void                  LoadFile(
  String                        lFn )
  {
    if ( lFn != null )
    {
      FileInputStream           lIs = null;
      PbnInputStream            lPbnIs;
      PbnFile                   lPbnFile;

      try
      {
        lIs = new FileInputStream( lFn );
      }
      catch ( Exception e )
      {
      }

      lPbnIs = new PbnInputStream( (InputStream) lIs );
      lPbnFile = new PbnFile( lPbnIs, null );

      LoadFile( lPbnFile );
    }
  }

  private void                  LoadUrlFile()
  {
    String                      lFn = getParameter( "pbnfile" );

    if ( lFn != null )
    {
      URL                       lUrl;
      InputStream               lIs;
      PbnInputStream            lPbnIs;
      PbnFile                   lPbnFile;

      try
      {
        lUrl = new URL( getCodeBase(), lFn );
      }
      catch ( MalformedURLException e )
      {
        return;
      }

      try
      {
        lIs = lUrl.openStream();
      }
      catch ( IOException e )
      {
        return;
      }

      lPbnIs = new PbnInputStream( lIs );
      lPbnFile = new PbnFile( lPbnIs, null );

      LoadFile( lPbnFile );
    }
  }

  private PbnFile               GetFile(
  String                        lFilename )
  {
    RandomAccessFile            lImportRaf;

    try
    {
      lImportRaf = new RandomAccessFile( lFilename, "r" );
    }
    catch ( Exception e )
    {
      return null;
    }

    PbnInputStream              lPbnIs = new PbnInputStream( lImportRaf );
    PbnFile                     lPbnFile = new PbnFile( lPbnIs, null );

    return lPbnFile;
  }

  public void                   LoadFile(
  PbnFile                       oPbnFile )
  {
    oPbnFile.Read();
    mPbnVwHndlr.NewGames( oPbnFile );
  }
}
