/*
 * File   :     PbnViewer.java
 * Author :     Tis Veugen
 * Date   :     2009-10-05
 * PBN    :     2.1
 *
 * History
 * -------
 * 2001-09-20 Made uniform files
 * 2007-08-27 Added VERSION_21
 * 2009-10-05 Set minimum window size
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import java.applet.*;
import java.net.*;

public class PbnViewer extends Frame
{
  public static boolean         mbApplet = false;

  private boolean               mbVwApplet = false;
  private Frame                 mFrame = null;

  private PanelScreen           mPanelScreen;
  private PbnVwHndlr            mPbnVwHndlr;
  private PbnMenu               mPbnMenu;

  public void                   SetFrame(
  Frame                         lFrame )
  {
    mbVwApplet = false;
    mFrame = lFrame;

    addWindowListener( new WindowAdapter()
                       {
                         public void windowClosing(
                         WindowEvent evt )
                         {
                            setVisible( false );
                            System.exit( 0 );
                         }
                       }
                     );
  }

  public void                   init()
  {
    PbnViewer.mbApplet = mbVwApplet;
    PbnGen.SetNoVerify();
    PbnGen.SetVersion( PbnGen.VERSION_21 );

    if ( PbnViewer.mbApplet )
    {
//      MyImages.GetImages( this );
    }
    else
    {
      MyImages.GetImages();
    }
    mPbnVwHndlr  = new PbnVwHndlr();

    if ( mFrame != null )
    {
      mPbnMenu = new PbnMenu( mFrame, mPbnVwHndlr );
    }

    mPanelScreen = new PanelScreen( mPbnVwHndlr );
    mPbnVwHndlr.SetPanelScreen( mPanelScreen );
    add( mPanelScreen );

    if ( PbnViewer.mbApplet )
    {
//      LoadUrlFile();
    }
  }

  private void                  LoadFile(
  String                        lFn )
  {
    if ( lFn != null )
    {
      FileInputStream           lIs = null;
      PbnInputStream            lPbnIs;
      PbnFile                   lPbnFile;

      try
      {
        lIs = new FileInputStream( lFn );
      }
      catch ( Exception e )
      {
      }

      lPbnIs = new PbnInputStream( (InputStream) lIs );
      lPbnFile = new PbnFile( lPbnIs, null );

      LoadFile( lPbnFile );
    }
  }
/*
  private void                  LoadUrlFile()
  {
    String                      lFn = getParameter( "PbnFile" );

    if ( lFn != null )
    {
      URL                       lUrl;
      InputStream               lIs;
      PbnInputStream            lPbnIs;
      PbnFile                   lPbnFile;

      try
      {
        lUrl = new URL( getCodeBase(), lFn );
      }
      catch ( MalformedURLException e )
      {
        return;
      }

      try
      {
        lIs = lUrl.openStream();
      }
      catch ( IOException e )
      {
        return;
      }

      lPbnIs = new PbnInputStream( lIs );
      lPbnFile = new PbnFile( lPbnIs, null );

      LoadFile( lPbnFile );
    }
  }
*/
  private PbnFile               GetFile(
  String                        lFilename )
  {
    RandomAccessFile            lImportRaf;

    try
    {
      lImportRaf = new RandomAccessFile( lFilename, "r" );
    }
    catch ( Exception e )
    {
      return null;
    }

    PbnInputStream              lPbnIs = new PbnInputStream( lImportRaf );
    PbnFile                     lPbnFile = new PbnFile( lPbnIs, null );

    return lPbnFile;
  }

  public void                   LoadFile(
  PbnFile                       oPbnFile )
  {
    oPbnFile.Read();
    mPbnVwHndlr.NewGames( oPbnFile );
  }

  public static void            main(
  String []                     args )
  {
    PbnViewer                   lPbnViewer = new PbnViewer( );

    lPbnViewer.SetFrame( lPbnViewer );
    lPbnViewer.init();
    lPbnViewer.setSize( 640, 532 );
    lPbnViewer.setMinimumSize( new Dimension( 640, 532 ) );
    lPbnViewer.pack();
    lPbnViewer.show();
    if ( args.length > 0 )
    {
      lPbnViewer.LoadFile( args[0] );
    }
  }
}
